﻿Array.prototype.max = function () {
  var max = this[0];
  var len = this.length;
  for (var i = 1; i < len; i++) if (this[i] > max) max = this[i];
  if (max == undefined) return 0;
  return max;
}
Array.prototype.min = function () {
  var min = this[0];
  var len = this.length;
  for (var i = 1; i < len; i++) if (this[i] < min) min = this[i];
  if (min == undefined) return 0;
  return min;
}
$(document).ready(function () {
  $.ajaxSetup({
    cache: false
			, complete: function (jqXHR, textStatus) {
			  if (jqXHR.responseText == "SESSION EXPIRED") {
			    location.href = "Login.aspx";
			  } else {
			    if (textStatus == "timeout") {
			      alert("Ajax request is timeout");
			    }
			  }
			}
			, error: function (x, jqxhr, settings, exception) {
			  if (x.responseText == "SESSION EXPIRED") {
			    location.href = "Login.aspx";
			  }
			}
  });
  OFFICEWALL.postFlagCnt();
  OFFICEWALL.globeNotificationCnt();
  OFFICEWALL.favUserPostCnt();

  OFFICEWALL.init();
  OFFICEWALL.setWM($("body"));
  OFFICEWALL.loadSchduler();
  OFFICEWALL.loadFavoriteUser();
  OFFICEWALL.getAdvancedSetting();
});
var OFFICEWALL = {
  myKey: '',
  postType: '',
  prevType: '',
  fUserKey: '',
  postID: 0,
  pIndx: 1,
  pSize: 10,
  tPage: 0,
  tRows: 0,
  init: function () {
    OFFICEWALL.setTab();
    $("#post").empty().css("height", "");
    $("#ShowMore").hide();

    var loading = $(".loading");
    loading.show();

    var $createpost = $(".createpost");
    if ($createpost.get(0)) {
      if (OFFICEWALL.postType != "") {
        $createpost.hide();
      } else {
        $createpost.show();
      }
    }
    OFFICEWALL.pIndx = 1;
    $.getJSON("AjaxRequest.aspx?mode=postlist&type=" + OFFICEWALL.postType + "&fuserkey=" + OFFICEWALL.fUserKey + "&postid=" + OFFICEWALL.postID + "&pindex=" + OFFICEWALL.pIndx + "&psize=" + OFFICEWALL.pSize, function (data) {
      loading.hide();
      OFFICEWALL.tRows = data.Total;
      OFFICEWALL.setTotPage();
      OFFICEWALL.appendPostTemplate(data.Data, false);
      OFFICEWALL.windowScroll();
      OFFICEWALL.panelDefaultHeight();
    });
  },
  setTotPage: function () {
    OFFICEWALL.tPage = Math.floor(OFFICEWALL.tRows / OFFICEWALL.pSize);
    if ((OFFICEWALL.tRows % OFFICEWALL.pSize) > 0) {
      OFFICEWALL.tPage = OFFICEWALL.tPage + 1;
    }
  },
  home: function () {
    if (OFFICEWALL.postType != "") {
      OFFICEWALL.clearData();
      OFFICEWALL.init();
    }
  },
  clearData: function () {
    OFFICEWALL.prevType = OFFICEWALL.postType;
    OFFICEWALL.postType = "";
    OFFICEWALL.fUserKey = "";
    OFFICEWALL.postID = 0;
  },
  setTab: function () {
    if (OFFICEWALL.prevType == "AFU" && OFFICEWALL.postType != "AFU") {
      OFFICEWALL.saveViewFavPostDate();
    }
    var UserListBox = $("#UserListBox");
    var PostBox = $("#PostBox");
    var $headericon = $(".header_icon");
    var $aglobe = $(".a_globe", $headericon);
    var $aflag = $(".a_flag", $headericon);
    var $afav = $(".a_fav", $headericon);
    var $asetting = $(".a_setting", $headericon);

    UserListBox.hide();
    PostBox.show();
    $("a", $headericon).removeClass("sel");
    if (OFFICEWALL.postType != "FU") {
      OFFICEWALL.clearFavoriteSelection();
    }
    if (OFFICEWALL.postType != "P") {
      OFFICEWALL.clearNotifySelection();
    }
    if (OFFICEWALL.postType != "") {
      OFFICEWALL.hidepost();
    }
    switch (OFFICEWALL.postType) {
      case "F":   //Flag
        $aflag.addClass("sel");
        break;
      case "AFU": // All Favorite Users Recent Post
        $afav.addClass("sel");
        break;
      case "S":   //Settings
        UserListBox.show();
        PostBox.hide();
        $asetting.addClass("sel");
        break;
      case "":    //Default all posts
        $aglobe.addClass("sel");
        break;
    }
  },
  showSetting: function () {
    OFFICEWALL.clearData();
    OFFICEWALL.postType = "S"; //Setting
    OFFICEWALL.setTab();
    var usercnt = UserCollection.getUserCount();
    var $userlist = $("#UserList");
    var trlen = $("> tbody > tr", $userlist).length;
    if (usercnt == 0 || trlen == 0) {
      OFFICEWALL.initSettingGrid();
    }
  },
  panelDefaultHeight: function () {
    var $postpanel = $(".post_panel");
    var $friendpanel = $(".friend_panel");
    var $post = $("#post");

    /*$post.css("height", "");
    if ($post.height() < $friendpanel.height()) {
    if ($(".showmore").css("display") == "none" && $("#dvpost").css("display") == "none") {
    $post.height($friendpanel.height());
    }
    }*/

    /*$postpanel.css("height", "");
    if ($postpanel.height() < $friendpanel.height()) {
    $postpanel.height($friendpanel.height() + 10);
    }*/
  },
  windowScroll: function () {
    var lastpost = $(".post_box_main:last").get(0);
    var showmore = $("#ShowMore");
    showmore.hide();
    if (OFFICEWALL.pIndx < OFFICEWALL.tPage) {
      showmore.show();
    } else {
      $(".line", lastpost).remove();
      if (OFFICEWALL.tRows > 0) {
        OFFICEWALL.saveViewFavPostDate();
        OFFICEWALL.prevType = "";
      }
    }
    return;

    var lastpost = $(".post_box_main:last").get(0);
    var firstpostid = 0;
    if (lastpost) {
      firstpostid = parseInt(lastpost.id.replace("p", ""));
      //firstpostid = $(lastpost).attr("dt")
    }
    $.get("AjaxRequest.aspx?mode=getpostcount&lpid=" + firstpostid + "&type=" + OFFICEWALL.postType + "&fuserkey=" + OFFICEWALL.fUserKey + "&postid=" + OFFICEWALL.postID, function (data) {
      if (parseInt(data) > 0) {
        showmore.show();
      } else {
        $(".line", lastpost).remove();
      }
    });
    /*
    $(window).scroll(function () {
    if($(window).scrollTop()==$(document).height()-$(window).height()) {
    $(window).unbind("scroll");
    var loading=$(".loading");
    loading.show();
    OFFICEWALL.loadOldPost();
    }
    });
    */
  },
  appendPostTemplate: function (data, isOldPost) {
    var post = $("#post");
    var post_box_main = $(".post_box_main:first", post);
    $.each(data, function (i, item) {
      var p = $("#p" + item.PostID, post).get(0);
      if (!p) {
        if (isOldPost) {
          $("#posttemplate").tmpl(item).appendTo(post);
        } else {
          if (post_box_main.get(0)) {
            $("#posttemplate").tmpl(item).insertBefore(post_box_main);
          } else {
            $("#posttemplate").tmpl(item).appendTo(post);
          }
        }
        OFFICEWALL.hideMoreComments(item.PostID);
      }
    });
    OFFICEWALL.setWM(post);
  },
  hideMoreComments: function (postid) {
    var $p = $("#p" + postid);
    var $pc = $("#pc" + postid, $p);
    var $vc = $(".viewcomments", $pc);
    var clen = $(".com_box", $pc).length - 1;
    if ($("#wc" + postid, $p).get(0)) {
      clen = clen - 1;
    }
    if (clen > 2) {
      $(".com_box:lt(" + (clen - 1) + ")", $pc).hide();
      $vc.show();
    } else {
      $vc.remove();
    }
  },
  showAllComments: function (postid) {
    var $p = $("#p" + postid);
    $(".com_box", $p).show();
    $(".viewcomments", $p).remove();
  },
  loadOldPost: function () {
    $("#ShowMore").hide();
    var loading = $(".loading");
    loading.show();
    OFFICEWALL.pIndx = OFFICEWALL.pIndx + 1;
    $.getJSON("AjaxRequest.aspx?mode=postlist&type=" + OFFICEWALL.postType + "&fuserkey=" + OFFICEWALL.fUserKey + "&postid=" + OFFICEWALL.postID + "&pindex=" + OFFICEWALL.pIndx + "&psize=" + OFFICEWALL.pSize, function (data) {
      OFFICEWALL.tRows = data.Total;
      OFFICEWALL.setTotPage();
      loading.hide();
      if (data.Data.length > 0) {
        OFFICEWALL.appendPostTemplate(data.Data, true);
      }
      OFFICEWALL.windowScroll();
      OFFICEWALL.panelDefaultHeight();
    });
  },
  postDetail: function (postid) {
    var container = $(".p_container");
    container.empty();
    container.removeClass("p_like");
    var pdetail = $('#pdetail');
    pdetail.css("background-color", "#000000");
    $(".p_title", pdetail).remove();
    pdetail.bPopup({
      fadeSpeed: 'fast',
      positionStyle: 'fixed'
    });

    pdetail.addClass("ajaxload_w");
    $.getJSON("AjaxRequest.aspx?mode=postdetail&postid=" + postid, function (data) {
      pdetail.removeClass("ajaxload_w");
      $("#postdetailTemplate").tmpl(data).appendTo(container);
      var postfile = $(".post_file", pdetail);
      //postfile.addClass("ajaxload_w");
      var img = new Image();
      img.src = postfile.attr("f");
      $(img).hide()
      .load(function () {
        $(this).show();
        //postfile.removeClass("ajaxload_w");
      }).width("100%").height("100%");
      postfile.append(img);
      $(".p_message", pdetail).hide();
      OFFICEWALL.resizePostDetail(16);
      OFFICEWALL.setWM(pdetail);
    });
  },
  resizePostDetail: function (resizeW) {
    var pdetail = $('#pdetail');
    var panelW = pdetail.width();
    var panelH = pdetail.height();
    var originalW = parseInt(pdetail.attr("w"));
    var originalH = parseInt(pdetail.attr("h"));
    var maxW = originalW - resizeW;
    var maxH = originalH;
    var pos = new AbsolutePosition(maxW, maxH, originalW, originalH)
    $(".post_box", pdetail).width(panelW).height(panelH);
    $(".p_message", pdetail).height(panelH - 20);
    $(".photo_cover", pdetail).width(panelW - resizeW).height(panelH);
    var $gridsep = $(".grid_sep");
    $gridsep.height(panelH);
    $("a", $gridsep).css("margin-top", ((panelH - 20) / 2) + "px");
    if (panelW > originalW || panelH > originalH) {
      pos.newW = originalW;
      pos.newH = originalH;
    }
    var postfile = $(".post_file", pdetail);
    postfile.width(pos.newW).height(pos.newH).css("padding-top", ((panelH - pos.newH) / 2) + "px");
  }
  , showComment: function () {
    var $img = $("#imgsep");
    var msg_display = $(".p_message").css("display");
    if (msg_display == "none") {
      OFFICEWALL.resizePostDetail(320);
    }
    $(".p_message").animate({ width: 'toggle' }, 500, function () {
      if (msg_display == "none") {
        OFFICEWALL.resizePostDetail(320);
        OFFICEWALL.hideOverflowComments();
      } else {
        OFFICEWALL.resizePostDetail(16);
      }
    });
  }
  , hideOverflowComments: function () {
    var pdetail = $("#pdetail");
    var comments = $(".post_comments", pdetail);
    var postdesc = $(".post_desc", pdetail);
    var pOffset = pdetail.offset();
    var dOffset = postdesc.offset();
    var tHeight = pdetail.height();
    var pDescHeight = postdesc.get(0).scrollHeight;
    var $commenttxt = $(".comment_txt", pdetail);
    var maxPostDescH = tHeight - (dOffset.top - pOffset.top) - 70;
    var availableComments = false;
    if (comments.get(0)) {
      availableComments = true;
    }
    if (availableComments == false) {
      maxPostDescH = maxPostDescH - $commenttxt.height();
    }
    if (pDescHeight > maxPostDescH) {
      if (maxPostDescH < 100) maxPostDescH = 100;
      postdesc.height(maxPostDescH).width(317);
    } else {
      postdesc.height(pDescHeight).width(300);
    }
    if (availableComments == false) {
      return;
    }
    var cOffset = comments.offset();
    var cHeight = cOffset.top - pOffset.top + 40;
    $($(".com_box", pdetail).get().reverse()).each(function () {
      cHeight = cHeight + $(this).height();
      if (cHeight > tHeight) {
        if ($(this).hasClass("comment_txt") == false) {
          $(this).hide();
        }
      } else {
        $(this).show();
      }
    });
  },
  loadSchduler: function () {
    setTimeout(function () {
      if (OFFICEWALL.postType == "") {
        OFFICEWALL.loadDynamicData();
      } else {
        OFFICEWALL.globeNotificationCnt();
        OFFICEWALL.favUserPostCnt();
      }
      OFFICEWALL.loadSchduler();
    }, (1000 * 60)); //Five minute;
  },
  loadDynamicData: function () {
    $.getJSON("AjaxRequest.aspx?mode=latestpostlist", function (data) {
      $.each(data, function (i, item) {
        item.PostLikeCount = 0;
        item.PostLike = [];
        item.PostComment = [];
      });
      OFFICEWALL.appendPostTemplate(data, false);
      //Get latest commants
      $.getJSON("AjaxRequest.aspx?mode=latestcommentlist", function (data) {
        $.each(data, function (i, item) {
          item.CommentLikeCount = 0;
          item.CommentLike = [];
          OFFICEWALL.appendCommentTemplate(item);
        });
        OFFICEWALL.calCommentCnt();
      });
      //Get latest like list
      $.getJSON("AjaxRequest.aspx?mode=latestpostlikelist", function (data) {
        $.each(data, function (i, item) {
          OFFICEWALL.postLikeCnt(item);
        });
      });
      OFFICEWALL.globeNotificationCnt();
      OFFICEWALL.favUserPostCnt();
    });
  },
  initSettingGrid: function () {
    try {
      $("#UserList")
		    .flexigrid({
		      usepager: true
			    , useBoxStyle: false
			    , url: "AjaxRequest.aspx?mode=userlist"
			    , onSubmit: function (p) {
			      return true;
			    }
			    , onTemplate: function (tbody, data) {
			      OFFICEWALL.addUsersToCol(data.Data);
			      $("#UserListTemplate").tmpl(data).appendTo(tbody);
			    }
			    , onSuccess: function (g, data, p) {
			      var $flexigrid = $(".flexigrid");
			      var $bDivBox = $(".bDivBox", $flexigrid);
			      var maxH = $(window).height() - $flexigrid.offset().top - 50;
			      var flexW = $flexigrid.width();
			      if ($flexigrid.height() > maxH) {
			        $flexigrid.height(maxH);
			        $bDivBox.width(flexW - 19);
			      } else {
			        $bDivBox.width(flexW - 2);
			      }
			    }
          , rpOptions: [25, 50, 100, 200]
			    , rp: 25
			    , resizeWidth: false
			    , method: "GET"
			    , sortname: "UserName"
			    , sortorder: ""
			    , autoload: true
			    , height: 0
		    });
    } catch (e) {
      alert(e);
    }
  },
  getUsers: function (data) {
    var url = "AjaxRequest.aspx?mode=userlist";
    $.getJSON(url, function (data) {
      OFFICEWALL.addUsersToCol(data.Data);
      OFFICEWALL.searchUserFromCol();
    });
  },
  addUsersToCol: function (data) {
    UserCollection.deleteAllUsers();
    $.each(data, function (i, user) {
      if (OFFICEWALL.myKey != user.UserKey) {
        UserCollection.addUser(user);
      }
    });
  },
  searchUser: function () {
    var usercnt = UserCollection.getUserCount();
    $(".searchuser").addClass("ajaxload");
    if (usercnt == 0) {
      OFFICEWALL.getUsers();
    } else {
      OFFICEWALL.searchUserFromCol();
    }
  },
  searchUserFromCol: function () {
    var $searchuser = $(".searchuser");
    var sValue = $("#tSearchUser").val();

    $searchuser.removeClass("suser_overflow");
    if (sValue == "") {
      $searchuser.removeClass("ajaxload");
      $searchuser.empty();
      OFFICEWALL.panelDefaultHeight();
      return;
    }
    var users = UserCollection.searchUsers(sValue);
    OFFICEWALL.appendSearchUser(users);
    OFFICEWALL.panelDefaultHeight();
  },
  appendSearchUser: function (users) {
    var $searchuser = $(".searchuser");
    $searchuser.removeClass("ajaxload");
    $searchuser.empty();
    if (users.length == 0) {
      $searchuser.html("No users found!");
      return;
    }
    $.each(users, function (i, user) {
      $("#searchUserTemplate").tmpl(user).appendTo($searchuser);
    });
    if ($searchuser.height() > 300) {
      $searchuser.addClass("suser_overflow");
    }
  },
  supportHoverIE7: function () {
    if ($.browser.msie && parseInt($.browser.version, 10) === 7) {
      var zIndexNumber = 5000;
      // Put your target element(s) in the selector below!
      $("#FavoriteUsers .user_box").each(function () {
        $(this).css('zIndex', zIndexNumber);
        zIndexNumber -= 10;
      });
    }
  },
  saveSetting: function (chk, username, userkey) {
    var tr = $(chk).parents("tr:first");
    var ispost = $("#IsPost", tr).get(0).checked;
    var iscomment = $("#IsComment", tr).get(0).checked;
    var params = new Array();
    params[params.length] = { name: "mode", value: "createsetting" };
    params[params.length] = { name: "userkey", value: userkey };
    params[params.length] = { name: "username", value: username };
    params[params.length] = { name: "ispost", value: ispost };
    params[params.length] = { name: "iscomment", value: iscomment };
    $.post("AjaxRequest.aspx", params);
  },
  setWM: function (target) {
    $(".water_mark", target).each(function () {
      var ify = $(this).attr("ify");
      if (ify != "true") {
        $(this).defaultify($(this).attr("wmvalue"));
        $(this).attr("ify", "true");
      }
    });
  },
  resetForm: function (frm) {
    $(":input[type='text']", frm).val("");
    $("textarea", frm).val("");
    $(":input[type='checkbox']", frm).each(function () { this.checked = false; });
    $("#Filename").val("");
    $("#hfilename").val("");
    OFFICEWALL.clearFile();
  },
  showpost: function () {
    $("#dvpost").show();
    $("#Title").focus();
    OFFICEWALL.panelDefaultHeight();
  },
  hidepost: function () {
    $("#dvpost").hide();
    OFFICEWALL.panelDefaultHeight();
  },
  createpost: function () {
    var frm = $("#frmOfficeWallPost");
    var tpost = $("#Message", frm);

    tpost.val(tpost.val().replace("Message...", ""));
    tpost.val(tpost.val().replace(/\n/g, "<br/>"));

    if ($.trim($("#Title").val()) == "" || $("#Title").val() == "Title...") { alert("Title is required!"); $("#Title").focus(); return; }
    if ($.trim($("#Title").val()).length > 100) { alert("Title must be under 100 characters."); $("#Title").focus(); return; }
    if ($.trim(tpost.val()) == "") { alert("Message is required!"); $("#Message").focus(); return; }
    var fname = $("#Filename").val();
    if ($.trim(fname) != "") {
      if (OFFICEWALL.validateFile(fname) == false) {
        OFFICEWALL.clearFile();
        $("#Filename").focus(); return;
      }
      OFFICEWALL.ajaxFileUpload();
    } else {
      OFFICEWALL.savepost();
    }
  },
  validateFile: function (fname) {
    var ext = fname.substring(fname.lastIndexOf('.') + 1).toLowerCase();
    if (!(ext == "gif" || ext == "jpeg" || ext == "jpg" || ext == "png")) {
      alert("*.gif, jpg, jpeg or png only allowed!");
      return false;
    }
    return true;
  },
  savepost: function () {
    var frm = $("#frmOfficeWallPost");
    var url = 'AjaxRequest.aspx';
    var iload = $("#imgloadpost");
    var tpost = $("#Message", frm);

    iload.show();
    $.ajax({
      type: "POST",
      url: url,
      data: frm.serializeArray(),
      success: function (htmldata) {
        OFFICEWALL.clearFile();
        iload.hide();
        var data = $.parseJSON(htmldata);
        OFFICEWALL.resetForm(frm);
        $("#posttemplate").tmpl(data).prependTo("#post");
        OFFICEWALL.hidepost();
        tpost.val("");
        OFFICEWALL.panelDefaultHeight();
      }
    });
  },
  deletepost: function (postid) {
    if (confirm("Are you sure you want to delete?")) {
      var url = 'AjaxRequest.aspx?mode=deletepost&postid=' + postid;
      $.get(url, function (data) {
        if ($.trim(data) == "True") {
          $("#p" + postid).remove();
          OFFICEWALL.windowScroll();
          OFFICEWALL.panelDefaultHeight();
        }
      });
    }
  },
  newcomment: function (postid) {
    var $ncomment = $("#n_c" + postid);
    var pdv = $("#pc" + postid);
    var d = pdv.css("display");

    $ncomment.hide();
    //if (d == "display" || d == "" || d == "inline" || d == "block") {
    //  pdv.hide();
    //} else {
    pdv.show();
    OFFICEWALL.setWM(pdv);
    $("#wc" + postid).show();
    $('#Message', pdv).focus();
    //}
  },
  createcomment: function (frm) {
    try {
      var mes = $("#Message", frm);
      mes.val(mes.val().replace("Write a comment...", ""));
      if ($.trim(mes.val()) == "") {
        alert("Comment is required");
        mes.focus();
        return false;
      }
      $.ajax({
        type: "POST",
        url: "AjaxRequest.aspx?mode=createcomment",
        data: $(frm).serializeArray(),
        success: function (htmldata) {
          mes.get(0).rows = 1;
          mes.val("").focus();
          var data = $.parseJSON(htmldata);
          OFFICEWALL.appendCommentTemplate(data);
          OFFICEWALL.calCommentCnt();
        }
      });
    } catch (e) {
      alert(e);
    }
    return false;
  },
  beforecreatecomment: function (that, e) {
    if (typeof e == 'undefined' && window.event) { e = window.event; }
    if (e.shiftKey && e.keyCode == 13) {
      if ($(that).parents("#pdetail").get(0)) {
        OFFICEWALL.hideOverflowComments();
      }
      //that.rows++;
      $(that).height($(that).height() + 14);
    }
    else if (e.keyCode == 13) {
      OFFICEWALL.createcomment($(that).parents("form"));
      return false;
    } else {
      //that.rows = (that.value.split("\n").length || 1);
      $(that).height((that.value.split("\n").length || 1) * 14);
    }
  }
	, appendCommentTemplate: function (data) {
	  try {
	    var post = $("#pc" + data.PostID);
	    var txt = $(".comment_txt", post);
	    post.show();
	    txt.show();
	    var c = $("#c" + data.CommentID).get(0);
	    if (!c) {
	      if (txt.get(0)) {
	        $("#commentTemplate").tmpl(data).insertBefore(txt);
	      } else {
	        $("#commentTemplate").tmpl(data).appendTo(post);
	      }
	    }
	    OFFICEWALL.appendDetailCommentTemplate(data);
	  } catch (e) {
	    alert(e);
	  }
	}
	, appendDetailCommentTemplate: function (data) {
	  try {
	    var pdetail = $("#pdetail");
	    if (pdetail.css("display") == "none") return;
	    var post = $("#pc" + data.PostID, pdetail);
	    var txt = $(".comment_txt", post);
	    post.show();
	    var c = $("#c" + data.CommentID, pdetail).get(0);
	    if (!c) {
	      $("#commentdetailTemplate").tmpl(data).insertBefore(txt);
	    }
	    OFFICEWALL.hideOverflowComments();
	  } catch (e) {
	    alert(e);
	  }
	},
  deletecomment: function (commentid) {
    if (confirm("Are you sure you want to delete?")) {
      var url = 'AjaxRequest.aspx?mode=deletecomment&commentid=' + commentid;
      $.get(url, function (data) {
        if ($.trim(data) == "True") {
          var cmt = $("#c" + commentid)
          cmt.remove();
          var pdetail = $("#pdetail");
          if (pdetail.css("display") == "block") {
            $("#c" + commentid, pdetail).remove();
            OFFICEWALL.hideOverflowComments();
          }
          OFFICEWALL.calCommentCnt();
        }
      });
    }
  },
  calCommentCnt: function (target) {
    $(".post_box_main").each(function () {
      var clength = $(".com_box", this).length;
      var cmdlbl = $(".com_cnt", this);
      cmdlbl.html("");
      if ($(".comment_txt", this).get(0)) {
        clength = clength - 1;
      }
      if ($(".com_box:first", this).hasClass("viewcomments")) {
        clength = clength - 1;
      }
      if (clength > 0) {
        cmdlbl.html("&nbsp;(" + clength + ")");
      }
    });
  },
  postLike: function (postid, commentid) {
    var type = "p";
    var tid = postid;
    if (commentid > 0) {
      postid = parseInt($("#c" + commentid).parents(".post_comments").get(0).id.replace("pc", ""));
      type = "c";
      tid = commentid;
    }

    var $like = $("#" + type + "like" + tid);
    var $lnkpcnt = $("#lnk" + type + "cnt" + tid);

    var $dv = $lnkpcnt.next(".like_users");
    var $ul = $("ul", $dv);

    var $lnkpdot = $("#lnk" + type + "dot" + tid);
    var $likecnt = $("#" + type + "likecnt" + tid);
    var lcnt = parseInt($likecnt.html());
    var islike = "0";
    if ($like.html() == "Like") {
      islike = "1";
    }
    if (islike == "1") {
      lcnt = lcnt + 1;
      $like.html("Unlike");
      var lilen = $("li", $ul).length;
      if (lilen > 1) {
        $("li:first", $ul).after("<li id='l" + type + "me" + tid + "'>You" + (lcnt > 1 ? (lcnt == 2 ? "&nbsp;and&nbsp;" : ",&nbsp;") : "") + "</li>");
      }
    } else {
      lcnt = lcnt - 1;
      $like.html("Like");
      $("#l" + type + "me" + tid).remove();
    }
    if (lcnt == 0) {
      $lnkpcnt.hide();
      $lnkpdot.hide();
    } else {
      $lnkpcnt.show();
      $lnkpdot.show();
    }
    $likecnt.html(lcnt);

    var url = 'AjaxRequest.aspx?mode=savelike&postid=' + postid + "&commentid=" + commentid + '&like=' + islike;
    $.get(url, function (data) {
      //      if ($.trim(data) == "True") {
      //      }
    });
  },
  loadPostLikeDetail: function (ukey, postid, commentid) {
    if (commentid > 0) {
      postid = parseInt($("#c" + commentid).parents(".post_comments").get(0).id.replace("pc", ""));
    }
    var container = $(".p_container");
    container.empty();
    var pdetail = $('#pdetail');
    $(".p_title", pdetail).remove();
    pdetail.width(400).height(400).css("background-color", "#ffffff");
    pdetail.bPopup({
      fadeSpeed: 'fast',
      positionStyle: 'fixed'
    });
    container.addClass("p_like");
    pdetail.addClass("ajaxload");
    $.getJSON("AjaxRequest.aspx?mode=postlikelist&postid=" + postid + "&commentid=" + commentid, function (data) {
      pdetail.removeClass("ajaxload");
      var $pdv = $(document.createElement("div"));
      $pdv.addClass("fleft");
      $pdv.addClass("overflow");
      var $dvtitle = $(document.createElement("div"));
      $dvtitle.addClass("p_title");
      if (commentid > 0) {
        if (ukey == OFFICEWALL.myKey) {
          $dvtitle.html("Peoples who liked your comment");
        } else {
          $dvtitle.html("Peoples who liked this comment");
        }
      } else {
        if (ukey == OFFICEWALL.myKey) {
          $dvtitle.html("Peoples who liked your post");
        } else {
          $dvtitle.html("Peoples who liked this post");
        }
      }
      container.append($dvtitle);
      container.append($pdv);
      $pdv.height(container.height() - $dvtitle.get(0).offsetHeight).width(400);
      var $cdv = $(document.createElement("div"));
      $cdv.addClass("fleft");
      $pdv.append($cdv);
      $("#likeDetailTemplate").tmpl(data).appendTo($cdv);
      if ($cdv.height() > $pdv.height()) {
        $(".com_box", container).width(383);
      } else {
        $cdv.width(400);
      }
    });
  },
  showPostLikeUsers: function (that, postid, commentid) {
    var type = "p";
    var tid = postid;
    if (parseInt(commentid) > 0) {
      postid = parseInt($("#c" + commentid).parents(".post_comments").get(0).id.replace("pc", ""));
      type = "c";
      tid = commentid;
    }
    var $dv = $(that).parents("a").next(".like_users");
    var $ul = $("ul", $dv);
    var lilen = $("li", $ul).length;
    var html = "";
    var ppos = $(that).parents(".like").offset();
    var pos = $(that).offset();

    $dv.css({ 'left': (pos.left - ppos.left + 35) + 'px', 'top': '0px' }).show();
    if (lilen > 1) {
      return;
    }
    $ul.hide();
    $dv.addClass("ajaxload_w");
    $.getJSON("AjaxRequest.aspx?mode=postlikelist&postid=" + postid + "&commentid=" + commentid, function (data) {
      var lkelen = data.length;
      var $likecnt = $("#" + type + "likecnt" + tid);
      $likecnt.html(lkelen);
      $("li:gt(0)", $ul).remove();
      $.each(data, function (i, lke) {
        if (lke.IsMe == 1) {
          html = "<li id='l" + type + "me" + tid + "'>You" + ((lkelen > 1) ? ((lkelen == 2) ? "&nbsp;and&nbsp;" : ",&nbsp;") : "") + "</li>";
        } else {
          html = "<li uk='" + lke.UserKey + "'>" + lke.DisplayName + ((i < lkelen - 1) ? ((i == lkelen - 2) ? "&nbsp;and&nbsp;" : ",&nbsp;") : "") + "</li>"
        }
        $ul.append(html);
      });
      $dv.removeClass("ajaxload_w");
      $ul.show();
    });
  },
  hidePostLikeUsers: function (that) {
    var $dv = $(that).parents("a").next(".like_users");
    $dv.hide();
  },
  postLikeCnt: function (data) {
    var type = "p";
    var tid = data.PostID;
    if (parseInt(data.CommentID) > 0) {
      type = "c";
      tid = data.CommentID;
    }
    var $like = $("#" + type + "like" + tid);
    var $lnkpcnt = $("#lnk" + type + "cnt" + tid);
    var $dv = $lnkpcnt.next(".like_users");
    var $ul = $("ul", $dv);
    var $lnkpdot = $("#lnk" + type + "dot" + tid);
    var $likecnt = $("#" + type + "likecnt" + tid);
    var lcnt = parseInt($likecnt.html());

    if ($("li[uk='" + data.UserKey + "']", $ul).get(0)) {
      return;
    }
    lcnt = lcnt + 1;
    $lnkpcnt.show();
    $lnkpdot.show();
    $likecnt.html(lcnt);
    var lilen = $("li", $ul).length;
    if (lilen == 1) return;
    var $li;
    var hml;
    if (lcnt > 2) {
      $li = $("li:eq(" + (lilen - 2) + ")", $ul);
      hml = $li.html();
      $li.html(hml.replace("&nbsp;and&nbsp;", ",&nbsp"));
    }
    if (lcnt > 1) {
      $li = $("li:eq(" + (lilen - 1) + ")", $ul);
      hml = $li.html();
      $li.html(hml + "&nbsp;and&nbsp;");
    }
    $ul.append("<li uk='" + data.UserKey + "'>" + data.DisplayName + "</li>");
  },
  postFlag: function (that) {
    var $headericon = $(".header_icon");
    var $spn = $(".flag_cnt", $headericon);
    var $img = $(that);
    var $post = $img.parents(".post_box_main");
    var postid = $post.get(0).id.replace("p", "");
    var isflag;
    var flagcnt = parseInt($spn.html());

    if ($img.attr("flag") == "0") {
      isflag = "1";
      $img.attr("src", "images/flag-green.png");
      flagcnt = flagcnt + 1;
    } else {
      isflag = "0";
      $img.attr("src", "images/flag-black.png");
      flagcnt = flagcnt - 1;
      if (OFFICEWALL.postType == "F") {
        $post.remove();
        OFFICEWALL.panelDefaultHeight();
      }
    }
    $img.attr("flag", isflag);
    var url = 'AjaxRequest.aspx?mode=saveflag&postid=' + postid + '&flag=' + isflag;
    $.get(url, function (data) {
      if ($.trim(data) == "True") {
      }
    });
  },
  postFlagList: function () {
    OFFICEWALL.clearData();
    OFFICEWALL.postType = "F";
    OFFICEWALL.init();
  },
  postFlagCnt: function () {
    return;
    var $headericon = $(".header_icon");
    var $spn = $(".flag_cnt", $headericon);

    $.get("AjaxRequest.aspx?mode=getflagpostcount", function (data) {
      if (parseInt(data) > 0) {
        $spn.html(data);
        $spn.show();
      } else {
        $spn.hide();
      }
    });
  },
  showFindFriend: function () {
    var $ifavorites = $("#iFavorites");
    var $postbox = $("#PostBox");
    var $postpanel = $(".post_panel");
    var $friendpanel = $(".friend_panel");
    if ($friendpanel.css("display") == "none") {
      $ifavorites.attr("src", "images/star.png");
      $postpanel.addClass("grid_9");
      $postpanel.removeClass("omega");
      $friendpanel.show();
      $postbox.css("background-color", "#F9F9F9");
    } else {
      $ifavorites.attr("src", "images/star_off.png");
      $postpanel.removeClass("grid_9");
      $postpanel.addClass("omega");
      $friendpanel.hide();
      $postbox.css("background-color", "#fff");
      OFFICEWALL.home();
    }
  },
  addFriend: function (that) {
    var $favoriteuser = $("#FavoriteUsers");
    var $combox = $(that).parents(".com_box");
    var $panel = $(that).parents(".comments");
    var fukey = $panel.attr("u");
    var fdname = $(".uname", $panel).html();

    $.get("AjaxRequest.aspx?mode=savefriend&fuserkey=" + fukey + "&fdname=" + fdname, function (data) {
      if ($.trim(data) == "True") {
        var u = UserCollection.getUser(fukey);
        u.IsFriend = "1";
        $combox.remove();
        $("#favoriteUserTemplate").tmpl({ "FriendUserKey": u.UserKey, "FriendDisplayName": u.DisplayName }).appendTo($favoriteuser);
        OFFICEWALL.supportHoverIE7();
      }
    });
  },
  deleteFriend: function (that) {
    var $panel = $(that).parents(".user_box");
    var fukey = $panel.attr("u");
    if (confirm("Remove favorite user?")) {
      var url = 'AjaxRequest.aspx?mode=deletefriend&fuserkey=' + fukey;
      $.get(url, function (data) {
        if ($.trim(data) == "True") {
          var U = UserCollection.getUser(fukey);
          if (U) {
            U.IsFriend = "0";
          }
          $panel.remove();
          var sVal = $("#tSearchUser").val();
          if (sVal != "" && sVal != "Search & Add Favorite Users") {
            if (U.DisplayName.toLowerCase().indexOf(sVal) > -1) {
              var $searchuser = $(".searchuser");
              if ($(".com_box", $searchuser).length == 0) {
                $searchuser.empty();
              }
              $("#searchUserTemplate").tmpl(U).appendTo($searchuser);
            }
          }
        }
      });
    }
  },
  loadFavoriteUser: function () {
    var $favoriteuser = $("#FavoriteUsers");
    $.getJSON("AjaxRequest.aspx?mode=friendlist", function (data) {
      $.each(data, function (i, item) {
        $("#favoriteUserTemplate").tmpl(item).appendTo($favoriteuser);
      });
      OFFICEWALL.supportHoverIE7();
      OFFICEWALL.panelDefaultHeight();
    });
  },
  favoritePostList: function (that) {
    var $panel = $(that).parents(".user_box");
    var fukey = $panel.attr("u");

    OFFICEWALL.clearFavoriteSelection();
    $panel.addClass("sel");
    OFFICEWALL.clearData();
    OFFICEWALL.postType = "FU";
    OFFICEWALL.fUserKey = fukey;
    OFFICEWALL.init();
  },
  clearFavoriteSelection: function () {
    var $favoriteusers = $("#FavoriteUsers");
    $(".user_box", $favoriteusers).removeClass("sel");
  },
  globeNotificationCnt: function () {
    var $notification = $(".notification");
    var $ntfycnt = $(".ntfy_cnt", $notification);
    var pcnt = $(".com_box", $notification).length;

    $.getJSON("AjaxRequest.aspx?mode=notificationcount", function (data) {
      pcnt = parseInt(data);
      $ntfycnt.html(pcnt);
      if (pcnt > 0) {
        $ntfycnt.removeClass("no_ntfy");
        var $ntfydetail = $(".ntfy_detail");
        if ($ntfydetail.css("display") == "block") {
          OFFICEWALL.globeNotification("C");
          $ntfycnt.html("0");
          $ntfycnt.addClass("no_ntfy");
        }
      } else {
        $ntfycnt.addClass("no_ntfy");
      }
    });
  },
  globeNotification: function (from) {
    var $notification = $(".notification");
    var $ntfydetail = $(".ntfy_detail");
    var $ntfycnt = $(".ntfy_cnt", $notification);
    var pcnt = parseInt($ntfycnt.html());
    var ccnt = $(".com_box", $ntfydetail).length;

    if (from != "C") {
      $ntfycnt.html("0");
      $ntfycnt.addClass("no_ntfy");
      if ($ntfydetail.css("display") == "block") {
        $ntfydetail.hide();
        return;
      }
    }
    $ntfydetail.show();
    var unreadonly = 0;
    if (ccnt > 0) {
      unreadonly = 1;
    }
    $(".comments", $ntfydetail).removeClass("unread");
    $.getJSON("AjaxRequest.aspx?mode=notificationlist&unreadonly=" + unreadonly, function (data) {
      $.each(data, function (i, item) {
        $("#globeNotificationTemplate").tmpl(item).prependTo($ntfydetail);
      });
      if ($ntfydetail.height() > 374) {
        $ntfydetail.addClass("ntfy_overflow");
      } else {
        $ntfydetail.removeClass("ntfy_overflow");
      }
      OFFICEWALL.panelDefaultHeight();
    });
  },
  favUserPostCnt: function () {
    var $headericon = $(".header_icon");
    var $spn = $(".post_cnt", $headericon);
    var cnt = parseInt($spn.html());
    
    if (isNaN(cnt)) {
      cnt = 0;
    }
    $.get("AjaxRequest.aspx?mode=favuserpostcount", function (data) {
      data = parseInt(data);
      if (isNaN(data)) {
        data = 0;
      }
      cnt = cnt + data;
      if (cnt > 0) {
        $spn.html(cnt);
        $spn.show();
      } else {
        $spn.hide();
      }
    });
  },
  recentFavUserPostList: function () {
    var $headericon = $(".header_icon");
    var $spn = $(".post_cnt", $headericon);

    $spn.html("");
    $spn.hide();

    OFFICEWALL.clearData();
    OFFICEWALL.postType = "AFU"; //All favorites users's recent post
    OFFICEWALL.init();
  },
  saveViewFavPostDate: function () {
    if (OFFICEWALL.prevType == "AFU" || OFFICEWALL.postType == "AFU") {
      $.get("AjaxRequest.aspx?mode=savefavuserviewpostdate");
    }
  },
  notifyDetail: function (that, notifyid, postid) {
    OFFICEWALL.clearNotifySelection();
    $(that).removeClass("unread");
    $(that).addClass("sel");
    OFFICEWALL.clearData();
    OFFICEWALL.postType = "P";
    OFFICEWALL.postID = postid;
    //OFFICEWALL.updateNotification(notifyid);
    OFFICEWALL.init();
  },
  updateNotification: function (notifyid) {
    $.get("AjaxRequest.aspx?mode=updatenotification&notifyid=" + notifyid);
  },
  clearNotifySelection: function () {
    var $notification = $(".notification");
    $(".comments", $notification).removeClass("sel");
  },
  changeFile: function (that) {
    var fname = that.value.replace(/^.*[\\\/]/, '');
    if (OFFICEWALL.validateFile(fname) == false) {
      OFFICEWALL.clearFile();
      $("#Filename").focus(); return;
    }
    if (fname.length > 40) {
      fname = fname.substr(0, 40) + "...";
    }
    $("#sfname").html(fname);
    $("#ifletrash").show();
  },
  clearFile: function () {
    var $customfile = $(".custom_file");
    $customfile.html($customfile.html());
    $("#sfname").html("");
    $("#ifletrash").hide();
  },
  saveAdvancedSetting: function () {
    var period = $("#PostDeletePeriod").val();
    $.get("AjaxRequest.aspx?mode=saveadvancedsetting&postdeleteperiod=" + period);
  },
  getAdvancedSetting: function () {
    if ($("#UserListBox").get(0)) {
      $.getJSON("AjaxRequest.aspx?mode=advancedsetting", function (data) {
        if (data) {
          $("#PostDeletePeriod").val(data.PostDeletePeriod);
        }
      });
    }
  },
  isEnter: function (evnt) {
    if (evnt) {
      var charCode = evnt.keyCode || evnt.which;
      if (charCode == 13) {
        return true;
      }
    }
  },
  replaceURLWithHTMLLinks: function (text) {
    var exp = /(\b((https?|ftp|file):\/\/|www)[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
    var regex = new RegExp(exp);
    return text.replace(regex, function (matched) {
      return "<a class='link' href='" + (((matched.indexOf("http://") < 0) && (matched.indexOf("HTTP://") < 0) && (matched.indexOf("https://") < 0) && (matched.indexOf("HTTPS://") < 0)) ? "http://" + matched : matched) + "' target='_blank'>" + matched + "</a>";
    });

  },
  ajaxFileUpload: function () {
    var loading = $("#loading")
    loading.show();
    $.ajaxFileUpload({
      url: 'HFileUpload.ashx',
      secureuri: false,
      fileElementId: 'Filename',
      dataType: 'json',
      data: { name: 'logan', id: 'id' },
      success: function (data, status) {
        loading.hide();
        if (typeof (data.error) != 'undefined') {
          if (data.error != '') {
            alert(data.error);
            OFFICEWALL.clearFile();
          } else {
            $("#hfilename").val(data.msg);
            OFFICEWALL.savepost();
          }
        }
      },
      error: function (data, status, e) {
        loading.hide();
        alert(e);
      }
    }
      )
    return false;
  }
}
$.extend(window, {
  formatDate: function (date, cdate) {
    try {
      var d = eval('new' + date.toString().replace(/\//g, ' '));
      var cd = eval('new' + cdate.toString().replace(/\//g, ' '));
      //return dateFormat(d,"h:MM:ss TT dddd, mmmm dS, yyyy");
      //var fDate = (new Date()).getTime();
      var fDate = cd.getTime();
      var sDate = d.getTime();
      var dDiff = fDate - sDate;

      var one_day = 1000 * 60 * 60 * 24;
      var one_hour = 1000 * 60 * 60;
      var one_min = 1000 * 60;
      var one_sec = 1000;
      var diff = Math.round(dDiff / one_day);
      if (diff <= 0) {
        diff = Math.round(dDiff / one_hour);
        if (diff <= 0) {
          diff = Math.round(dDiff / one_min);
          if (diff <= 0) {
            diff = Math.round(dDiff / one_sec);
            if (diff <= 0) {
              return "just now";
            } else if (diff == 1) {
              return diff + " second ago";
            } else {
              return diff + " seconds ago";
            }
          } else if (diff == 1) {
            return diff + " minute ago";
          } else {
            return diff + " minutes ago";
          }
        } else if (diff == 1) {
          return diff + " hour ago";
        } else {
          return diff + " hours ago";
        }
      } else {
        return dateFormat(d, "d mmm, h:MM TT");
      }
    } catch (e) {
      return "";
    }
  },
  cbool: function (d) {
    if (d == null) return false; else return d;
  },
  carray: function (d) {
    return d;
  }
});
(function ($) {
  $.fn.defaultify = function (defaultValue) {
    return this.each(function (i) {
      var $this = $(this);
      var iswmexist = $this.attr("wm");
      if (iswmexist == undefined) {
        $this
                .attr("wm", true)
                .val(defaultValue)
                .focus(function (e) {
                  $this.addClass("def");
                  if ($.trim($this.val()) == defaultValue) {
                    $this.val("");
                  }
                })
                .blur(function (e) {
                  if ($.trim($this.val()) == "") {
                    $this.val(defaultValue); $this.removeClass("def");
                  }
                })
                ;
      }
    });
  };
})(jQuery);


(function ($) {
  // DOM Ready
  $(function () {
    $(".bClose").click(function () {
      $('#pdetail').bPopup().close();
    });
    $(".iflag").live("mouseover", function () {
      if ($(this).attr("src") == "images/flag-green.png") {
        $(this).attr("src", "images/flag-black.png");
      } else {
        $(this).attr("src", "images/flag-green.png");
      }
    }).live("mouseout", function () {
      if ($(this).attr("flag") == "0") {
        $(this).attr("src", "images/flag-black.png");
      } else {
        $(this).attr("src", "images/flag-green.png");
      }
    }).live("click", function () {
      OFFICEWALL.postFlag(this);
    });
    $("#tSearchUser").keyup(function () {
      OFFICEWALL.searchUser();
    });

    // Binding a click event
    // From jQuery v.1.7.0 use .on() instead of .bind()
    $(".pimage").live("click", function (e) {
      // Prevents the default action to be triggered. 
      e.preventDefault();

      var originalW = parseInt($(this).attr("w"));
      var originalH = parseInt($(this).attr("h"));
      var maxW = $(window).width();
      var maxH = $(window).height() - 50;
      var pos = new AbsolutePosition(maxW, maxH, originalW, originalH)
      var pdetail = $("#pdetail");

      if (pos.newW < 620) {
        if ((pos.newW + 320) < 620) {
          pdetail.width(620);
        } else {
          pdetail.width(pos.newW + 320);
        }
      } else {
        pdetail.width(pos.newW);
      }
      if (pos.newW < 300) {
        pdetail.height(300);
      } else {
        pdetail.height(pos.newH);
      }
      pdetail.attr("w", pos.newW).attr("h", pos.newH);

      var postid = $(this).parents(".post_box_main").get(0).id.replace("p", "");
      OFFICEWALL.postDetail(postid);
    });
  });
})(jQuery);

function AbsolutePosition(maxW, maxH, originalW, originalH) {
  this.newW = originalW;
  this.newH = originalH;
  if ((maxW < originalW) || (maxH < originalH)) {
    var percentW = maxW / originalW;
    var percentH = maxH / originalH;
    var percent = (percentH < percentW ? percentH : percentW);
    this.newW = parseInt(originalW * percent);
    this.newH = parseInt(originalH * percent);
  }
}

$(document).keydown(function (event) {
  if (event.keyCode == 27) {
    //FIXES FIREFOX GIF STOPPING
    event.preventDefault();
  }
});
