﻿var UserCollection = {
  Users: new Array(),
  addUser: function (data) {
    var U = UserCollection.Users[data.UserKey];
    if (!U) {
      U = new User();
    }
    U.UserKey = data.UserKey;
    U.DisplayName = data.DisplayName;
    U.IsFriend = data.IsFriend;
    UserCollection.Users[data.UserKey] = U;
  },
  removeUser: function (key) {
    //delete UserCollection.Users[key];
  },
  checkUserExists: function (key) {
    if (key in UserCollection.Users) {
      return true;
    } else {
      return false;
    }
  },
  getUser: function (key) {
    return UserCollection.Users[key];
  },
  getUserCount: function () {
    var uCnt = 0;
    for (var key in UserCollection.Users) {
      if (key != "max" && key != "min") {
        uCnt = uCnt + 1;
      }
    }
    return uCnt;
    //return UserCollection.Users.length;
  },
  getUsers: function () {
    return UserCollection.Users;
  },
  searchUsers: function (sVal) {
    sVal = sVal.toLowerCase();
    var sUsers = new Array();
    for (var key in UserCollection.Users) {
      if (key != "max" && key != "min") {
        var u = UserCollection.Users[key];
        if (u.DisplayName.toLowerCase().indexOf(sVal) > -1) {
          if (u.IsFriend == "0") {
            sUsers.push(u);
          }
        }
      }
    }
    return sUsers;
  },
  getGroups: function () {
    var groups = new Array();
    for (var key in UserCollection.Users) {
      var u = UserCollection.Users[key];
      var groupExist = false;
      $.each(groups, function (i, g) {
        if (g == u.GroupName) {
          groupExist = true;
        }
      });
      if (groupExist == false) {
        if (u.GroupName != undefined) {
          groups[groups.length] = u.GroupName;
        }
      }
    }
    groups.sort();
    return groups;
  },
  deleteAllUsers: function () {
    UserCollection.Users = new Array();
  }
}

function User() {
  this.UserKey = '';
  this.DisplayName = '';
  this.IsFriend = 0;
}